Index: /trunk/AddOn/TAcq/brbaseproc.cc
===================================================================
--- /trunk/AddOn/TAcq/brbaseproc.cc	(revision 3693)
+++ /trunk/AddOn/TAcq/brbaseproc.cc	(revision 3694)
@@ -18,13 +18,15 @@
 /* --Methode-- */
 BRBaseProcessor::BRBaseProcessor(RAcqMemZoneMgr& memgr)
-  : memgr_(memgr) 
+  : memgr_(memgr), vpaq_(memgr.NbFibres()), vpchk_(memgr.NbFibres()), vfgok_(memgr.NbFibres()), 
+    curfc_(memgr.NbFibres())
 {
   stop_ = false;
   for(size_t fib=0; fib<(size_t)memgr_.NbFibres(); fib++)  {
-    vpaq_.push_back(BRPaquet(NULL,memgr_.PaqSize()));
-    vpchk_.push_back(BRPaqChecker(true,0)); 
-    vfgok_.push_back(true);
-    curfc_.push_back(0);
+    vpaq_[fib]=BRPaquet(NULL,memgr_.PaqSize());
+    vpchk_[fib]=BRPaqChecker(true,0); 
+    vfgok_[fib]=true;
+    curfc_[fib]=0;
   }
+  fcfirst_=ttfirst_=0;
   totprocnpaq_=0;
 }
Index: /trunk/AddOn/TAcq/brbaseproc.h
===================================================================
--- /trunk/AddOn/TAcq/brbaseproc.h	(revision 3693)
+++ /trunk/AddOn/TAcq/brbaseproc.h	(revision 3694)
@@ -34,8 +34,12 @@
   bool stop_;  
   vector<BRPaquet> vpaq_;   // Vecteur de BRPaquet pour chaque fibre
+  vector<BRPaqChecker> vpchk_;
   vector<uint_8> vfgok_;    // Vecteur de flag si paquet OK pour chaque fibre
   vector<uint_8> curfc_;    // Vecteur de numero de FrameCounter pour chaque fibre
+
+  uint_8 fcfirst_;
+  uint_8 ttfirst_;
   bool fgokallfibers_;      // true -> paquets for all fibers OK
-  vector<BRPaqChecker> vpchk_;
+
   uint_8 totprocnpaq_; 
 };
Index: /trunk/AddOn/TAcq/brpaqu.h
===================================================================
--- /trunk/AddOn/TAcq/brpaqu.h	(revision 3693)
+++ /trunk/AddOn/TAcq/brpaqu.h	(revision 3694)
@@ -116,5 +116,5 @@
   // Cree d'un objet BRPaquet de taille paqsz sur la zone dst   
   BRPaquet(Byte* srcdst, int paqsz);
-  BRPaquet(int paqsz);
+  BRPaquet(int paqsz=16424);   // Set aussi de constructeur par defaut
   BRPaquet(BRPaquet const& paq);
 
Index: /trunk/AddOn/TAcq/brproc.cc
===================================================================
--- /trunk/AddOn/TAcq/brproc.cc	(revision 3693)
+++ /trunk/AddOn/TAcq/brproc.cc	(revision 3694)
@@ -33,5 +33,6 @@
 BRVisibilityCalculator::BRVisibilityCalculator(RAcqMemZoneMgr& memgr, string outpath, uint_4 nmean, 
 					       uint_4 freq1, uint_4 freq2, uint_4 nbfreq)
-  : BRBaseProcessor(memgr), outpath_(outpath), nmean_(nmean), numfreq1_(freq1), numfreq2_(freq2), nbinfreq_(nbfreq)
+  : BRBaseProcessor(memgr), outpath_(outpath), nmean_(nmean), numfreq1_(freq1), numfreq2_(freq2), nbinfreq_(nbfreq),
+    vpdata_(2*memgr.NbFibres())
     // , dtfos_(outpath+"visdt.fits", Fits_Create), visdt_(dtfos_, 1024, true);
 
@@ -42,4 +43,5 @@
   chanum_.SetSize(vismtx_.NRows());
   sa_size_t k=0;
+  for(size_t i=0; i<2*memgr_.NbFibres(); i++)  vpdata_[i]=NULL;
   for(size_t i=0; i<2*memgr_.NbFibres(); i++) {
     for(size_t j=i; j<2*memgr_.NbFibres(); j++) {
@@ -107,8 +109,8 @@
   */
   // On s'arrange pour mettre les canaux dans l'ordre pour les observations de Pittsburgh Nov 2009
-  for(size_t fib=0; fib<(size_t)memgr_.NbFibres(); fib++) 
-    vpdata.push_back(vpaq_[fib].Data1C());
-  for(size_t fib=0; fib<(size_t)memgr_.NbFibres(); fib++) 
-    vpdata.push_back(vpaq_[fib].Data2C());
+  for(size_t fib=0; fib<(size_t)memgr_.NbFibres(); fib++) {
+    vpdata_[2*fib] = vpaq_[fib].Data1C();
+    vpdata_[2*fib+1] = vpaq_[fib].Data2C();
+  }
 
   if (totnbpaq_%nmean_ == 0) {
@@ -132,10 +134,10 @@
   
   sa_size_t k=0;
-  for(size_t i=0; i<vpdata.size(); i++) {
-    for(size_t j=i; j<vpdata.size(); j++) {
+  for(size_t i=0; i<vpdata_.size(); i++) {
+    for(size_t j=i; j<vpdata_.size(); j++) {
       TVector< complex<r_4> > vis = vismtx_.Row(k);   k++;
       for(sa_size_t f=1; f<vis.Size(); f++) {
-	vis(f) += complex<r_4>((r_4)vpdata[i][f].realB(), (r_4)vpdata[i][f].imagB()) * 
-	  complex<r_4>((r_4)vpdata[j][f].realB(), -(r_4)vpdata[j][f].imagB());
+	vis(f) += complex<r_4>((r_4)vpdata_[i][f].realB(), (r_4)vpdata_[i][f].imagB()) * 
+	  complex<r_4>((r_4)vpdata_[j][f].realB(), -(r_4)vpdata_[j][f].imagB());
       }
     }
Index: /trunk/AddOn/TAcq/brproc.h
===================================================================
--- /trunk/AddOn/TAcq/brproc.h	(revision 3693)
+++ /trunk/AddOn/TAcq/brproc.h	(revision 3694)
@@ -39,5 +39,6 @@
   uint_4 numfreq1_,numfreq2_,nbinfreq_;
   uint_4 jf1_,jf2_,djf_;
-  uint_4 numfile_;
+
+  vector<TwoByteComplex*> vpdata_;
 
   double moyfc_, moytt_;
@@ -47,4 +48,5 @@
   DataTable visdt_;
 
+  uint_4 numfile_;
   uint_4 totnbpaq_;
   double* xnt_;
Index: /trunk/AddOn/TAcq/svv2mtx.cc
===================================================================
--- /trunk/AddOn/TAcq/svv2mtx.cc	(revision 3693)
+++ /trunk/AddOn/TAcq/svv2mtx.cc	(revision 3694)
@@ -63,10 +63,11 @@
     int nfreq=0;
     sscanf(arg[3],"%d,%d,%d",&jf1,&jf2,&nfreq);
+    int card=1;
+    if (narg>4) card=atoi(arg[4]); 
     cout << " ----- svv2mtx.cc Start - InOutPath= " << inoutpath << " IMin,Max,Step=" 
-         << imin << "," << imax << "," << istep << " JF=" << jf1 << "," << jf2 << "  ------- " << endl;
-    int card=1;
-    if (narg>4) card=atoi(arg[3]); 
+         << imin << "," << imax << "," << istep << " Card=" << card << endl;
+    cout << "Frequency num range JF=" << jf1 << "," << jf2 << "," << nfreq << "  ------- " << endl;
     ResourceUsage resu;
-    rc=ProcSVFiles(inoutpath, imin, imax, istep, jf1, jf2, card);
+    rc=ProcSVFiles(inoutpath, imin, imax, istep, jf1, jf2, nfreq, card);
     resu.Update();
     cout << resu;